
#ifndef _COMMON_H_
#define _COMMON_H_

typedef unsigned short Pixel;

void LoadFromBitmap(const char *FileName, int *Width, int *Height, Pixel **Buffer);
void DrawFrame(int Width, int Height, Pixel *Buffer);
void SetKeyState(const unsigned char *CurrentState);

void debugout(const char *Format, ...);
void halt(const char *Format, ...);

#ifdef _DEBUG
#define assert(cond) if(!cond) halt("Assertion failed in %s at line %d.\n", __FILE__, __LINE__)
#else
#define assert(cond)
#endif

#define KeyStateDown     1 // currently down, otherwise currently up
#define KeyStatePressed  2 // just pressed down (implies Down)
#define KeyStateReleased 4 // just released (implies !Down)

#define KeyCodeLeft  0
#define KeyCodeRight 1
#define KeyCodeUp    2
#define KeyCodeDown  3
#define KEYCODECOUNT 4

#endif // _COMMON_H_